<template>
  <nav
    class="breadcrumbs"
    itemscope=""
    itemtype='http://schema.org/BreadcrumbList'
    v-if="breadcrumbs && breadcrumbs.length">
    <div
      class="breadcrumb"
      itemprop="itemListElement"
      itemscope
      itemtype="http://schema.org/ListItem">
      <flink
        href="/"
        itemprop="item">
        <span itemprop="name">Главная</span>
      </flink>
      <div class="breadcrumb-divider">
        <img
          svg-inline
          src="~/assets/svg/redesign/breadcrumb-divider.svg">
      </div>
      <meta
        itemprop="position"
        :content="1">
    </div>
    <template v-for="(breadcrumb, index) in breadcrumbs">
      <div
        v-if="isLink(breadcrumb)"
        :key="`active_el${index}`"
        class="breadcrumb"
        itemprop="itemListElement"
        itemscope
        itemtype="http://schema.org/ListItem">
        <flink
          :href="breadcrumb.url"
          itemprop="item">
          <span
            v-if="breadcrumb.name"
            @click="$emit('emit-breadcrumb', index)"
            itemprop="name"> {{ breadcrumb.name }}</span>
        </flink>
        <div class="breadcrumb-divider">
          <img
            svg-inline
            src="~/assets/svg/redesign/breadcrumb-divider.svg">
        </div>
        <meta
          itemprop="position"
          :content="index + 2">
      </div>
      <div
        v-else-if="!isLink(breadcrumb) && breadcrumb.name"
        :key="`inactive_el${index}`"
        class="breadcrumb">
        <div>
          {{ breadcrumb.name }}
        </div>
        <div class="breadcrumb-divider">
          <img
            svg-inline
            src="~/assets/svg/redesign/breadcrumb-divider.svg">
        </div>
      </div>
    </template>
  </nav>
</template>

<script>
export default {
  name: 'AppBreadcrumbs',
  props: {
    breadcrumbs: {
      type: Array,
      default() { return []; },
    },
  },
  methods: {
    isLink(breadcrumb) {
      return breadcrumb && breadcrumb.url;
    },
    isLastElement(index) {
      return this.breadcrumbs && this.breadcrumbs.length && this.breadcrumbs.length - 1 === index;
    },
  },
};
</script>

<style scoped lang="postcss">
  .breadcrumbs {
    display: flex;
    flex-wrap: wrap;
    align-items: center;

    &._white {
      & > .breadcrumb {
        color: var(--bg-main);
        &:hover, &:focus {
        color: var(--color-on-dark-lighten);
        }
        &:last-of-type {
          color: var(--color-on-dark-lighten);
        }
      }
    }

    .breadcrumb {
      display: inline-flex;
      align-items: center;
      font-style: normal;
      font-weight: var(--font-weight-regular);
      font-size: 0.75rem;
      color: var(--color-main-lightest);
      cursor: pointer;

      & > a {
        color: currentColor;
        transition: color .3s var(--transition-easeOutQuad);
      }

      &:hover, &:focus {
        color: var(--color-main);
      }

      &:last-of-type {
        color: var(--color-main-darkest);
        pointer-events: none;

        .breadcrumb-divider {
          display: none;
        }
      }
    }

    .breadcrumb-divider {
      display: inline-flex;
      align-items: center;
      justify-content: center;
      margin-right: 0.625rem;
      margin-left: 0.625rem;

      .svg {
        width: 0.1875rem;
        height: auto;
        fill: currentColor;
        transition: fill .3s var(--transition-easeOutQuad);
      }
    }

    @media screen and (max-width: 980px) {
      .breadcrumb {
        flex-direction: row-reverse;
        font-size: 1rem;

        &:not(:first-of-type) {
          display: none;
        }

      // В мобилке надо показывать только ссылку на Главную

        &:first-of-type {
          .breadcrumb-divider {
            margin-left: 0;

            .svg {
              margin-bottom: 0.125rem;
              width: 0.375rem;
              transform: rotate(180deg);
            }
          }
        }
      }
    }
  }
</style>
